/************************************************************/
/*  HPC104-CPD132                                           */
/*  Library lebel1a Functions For Visual C					*/
/*	    file name:hubcp13l.c								*/
/*      OS       :Windows 9x/2000/XP						*/
/*      date     :2005/09/26     							*/
/*      version  :1.0.0.0 									*/
/*	Copyright(C) 2005  Hivertec Inc.  All Rights Reserved.	*/
/************************************************************/
#include	<windows.h>
#include	"hubcp130.h"
#include	"hubcp13l.h"

// ԍ
#define X_AX			0
#define Y_AX			1

#define ILL_PRM		0x0100
#define ILL_HNDL	0xffffffff

/********************************************************/
/*		샂[hffe[u	1:			*/
/********************************************************/
short mod_tbl[128] = {
/*  x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xa xb xc xd xe xf	*/
	 1, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,	/* 00-0f */
	 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0,	/* 10-1f */
	 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0,	/* 20-2f */
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 30-3f */
	 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0,	/* 40-4f */
	 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 50-5f */
	 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 60-6f */
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0		/* 70-7f */
};

/************************************************************/
/*					foCX֌W̊֐						*/
/************************************************************/
/* foCX̃I[vCfoCX̏						*/
/* FfoCXnh̃AhXCfoCX̃AhX */
DWORD hubcp132_DevOpen(DWORD* hDeviceID, HUBDEVINFO* hDevInfo)
{
	WORD	wAx;			/* 				*/
	DWORD	hDevID;			/* foCXnh	*/
	DWORD	dwRet;			/* ߂l			*/

	/* foCX̃I[v */
	dwRet = ubcp130_OpenDevice(&hDevID, hDevInfo);
	if(dwRet)										return dwRet;
	else		*hDeviceID = hDevID;

	/* ELSɐI|[g(B) */
	dwRet = ubcp130_wPortB(hDevID, CP13_ELSPOL, 0x00);
	if(dwRet)										return dwRet;

	/* DLS/PCSؑփ|[g(PCS) */
	dwRet = ubcp130_wPortB(hDevID, CP13_DLSPCS, 0x3f);
	if(dwRet)										return dwRet;

	/* Rp[^4o͐ؑփ|[g(o͕s) */
	dwRet = ubcp130_wPortB(hDevID, CP13_CP4PRT, 0x00);
	if(dwRet)										return dwRet;

	/* Rp[^5o͐ؑփ|[g(o͕s) */
	dwRet = ubcp130_wPortB(hDevID, CP13_CP5PRT, 0x00);
	if(dwRet)										return dwRet;

	/* WX^ */
	/* R}hobt@(\tgEFAZbg) */
	dwRet = ubcp130_wCmdW(hDevID, 0, 0x04);
	if(dwRet)										return dwRet;

	for (wAx = 0; wAx < 2; wAx++) {
		/* WX^(x[XxWX^:PRFL = 200) */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x81, 200l);
		if(dwRet)									return dwRet;

		/* WX^(쑬xWX^:PRFH = 2000) */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x82, 2000l);
		if(dwRet)									return dwRet;

		/* WX^([gWX^) */
		/* 		NbNg = 19,660,800Hz,  =  = 0.5b */
		/* 		PRFH = 2000, PRFL = 200, PRUR:[g */
		/* 		(b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800 */
		/* 		PRUR = 1364 */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x83, 1364l);
		if(dwRet)									return dwRet;

		/* WX^({ = 1{, PRMG = 299) */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x85, 299l);
		if(dwRet)									return dwRet;

		/* WX^(샂[h:PRMD = 0x8008000) */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x87, 0x8008000);
		if(dwRet)									return dwRet;

		/* WX^(ړʕ␳x:RFA = 200) */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x9b, 200l);
		if(dwRet)									return dwRet;

		/* WX^(ݒ1:RENV1 = 0x20434004) */
		/* 		wߏo:ʃpXw߂̐_ */
		/* 		OLS & DLS & SVALM = B, INPOS = A,  */
		/* 		ELS & SVALM͎~,DLSo = ̂,ׯȂ, */
		/* 		޴װ_Aرo͂Ȃ */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x9c, 0x20434004);
		if(dwRet)									return dwRet;

		/* WX^(ݒ2:RENV2 = 0x0020f555) */
		/* 		SVON, SVRSTėpo͐ݒ */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x9d, 0x0020f555);
		if(dwRet)									return dwRet;

		/* WX^(ݒ3:RENV3 = 0x00f00002) */
		/* 		_AFݻ+ݺތ_A(OLS+Z),  */
		/* 		CLROFFON & _Aر  */
		dwRet = ubcp130_wReg(hDevID, wAx, 0x9e, 0x00f00002l);
		if(dwRet)									return dwRet;

		/* WX^(CxgINTݒ:RIRQ = 1(~) */
		dwRet = ubcp130_wReg(hDevID, wAx, 0xac, 1l);
		if(dwRet)									return dwRet;

		/* SVON OFF */
		dwRet = ubcp130_wCmdW(hDevID, wAx, 0x10);
		if(dwRet)									return dwRet;

		/* SVRST OFF */
		dwRet = ubcp130_wCmdW(hDevID, wAx, 0x11);
		if(dwRet)									return dwRet;

		/* ~ */
		dwRet = ubcp130_wCmdW(hDevID, wAx, 0x4a);
		if(dwRet)									return dwRet;
	}
	return dwRet;
}

/********************************************************/
/* foCX̃N[Y 									*/
/* 		FfoCXnh 							*/
/********************************************************/
DWORD hubcp132_DevClose(DWORD hDevID)
{
	DWORD	dwRet;						/* ߂l */

	/* foCX̃N[Y */
	dwRet = ubcp130_CloseDevice(hDevID);
	return dwRet;
}

/********************************************************/
/*					ݒn̊֐					*/
/********************************************************/
/********************************************************/
/* _A̐ݒ 									*/
/* 		FfoCXnhCC_A[h 		*/
/********************************************************/
DWORD hubcp132_SetOrgMode(DWORD hDevID, WORD axis, WORD mode)
{
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;

	/* ԍ0`1ȊO܂ */
	/* _A[h0`12ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100; 
	if((mode < 0) || (mode > 12))	return 0x0100;

	/* WX^3(RENV3)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xde, &dwData);
	if(dwRet)						return dwRet;

	dwData &= 0xfffffff0;
	/* Orgmode9̎CCTR2͂w߈ʒuɂ */
	/* (Orgmode9ȊO̎CCTR2͂͋@Bʒu) */
	if(mode == 9)	dwData |= 0x00000100;
	else			dwData &= 0xfffffef0;
	dwData |= mode;

	/* WX^3(RENV3) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9e, dwData);
	return dwRet;
}

/********************************************************/
/* ELS̐ݒ 											*/
/* 		FfoCXnhCCɐC~@ 		*/
/********************************************************/
DWORD hubcp132_SetEls(DWORD hDevID, WORD axis, WORD pol, WORD stop)
{
	BYTE	byData;
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* ELSɐ|[gǍ */
	dwRet = ubcp130_rPortB(hDevID, CP13_ELSPOL, &byData);
	if(dwRet)						return dwRet;

	if(pol) byData |= (BYTE) (0x01 << axis);	/* A */
	else 	byData &= (BYTE)~(0x01 << axis);	/* B */

	/* ELSɐ|[g */
	dwRet = ubcp130_wPortB(hDevID, CP13_ELSPOL, byData);
	if(dwRet)						return dwRet;

	/* WX^P(RENV1)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)						return dwRet;

	if(stop)	dwData |= (DWORD) 0x8;	/* ~ */
	else		dwData &= (DWORD)~0x8;	/* ~ */

	/* WX^P(RENV1) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/********************************************************/
/* OLS̐ݒ 											*/
/* 		FfoCXnhCCɐ 				*/
/********************************************************/
DWORD hubcp132_SetOls(DWORD hDevID, WORD axis, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* WX^P(RENV1)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)						return dwRet;

	if(pol) dwData |= (DWORD) 0x80;	/* A */
	else	dwData &= (DWORD)~0x80;	/* B */

	/* WX^P(RENV1) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/********************************************************/
/* SVALM̐ݒ 											*/
/* 		FfoCXnhCCɐC~@ 		*/
/********************************************************/
DWORD hubcp132_SetSvAlm(DWORD hDevID, WORD axis, WORD pol, WORD stop)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* WX^P(RENV1)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)						return dwRet;

	if(pol) dwData |= (DWORD) 0x200;		/* A */
	else	dwData &= (DWORD)~0x200;		/* B */

	if(stop)	dwData |= (DWORD) 0x0100;	/* ~ */
	else		dwData &= (DWORD)~0x0100;	/* ~ */

	/* WX^P(RENV1) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/************************************************************************/
/* GR[_Z̐ݒ 													*/
/* 		FfoCXnhCC_AŎgpy񐔁Cɐ 	*/
/************************************************************************/
DWORD hubcp132_SetEz(DWORD hDevID, WORD axis, WORD count, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* _AŎgpZ */
	count &= 0x000f;

	/* WX^3(RENV3)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xde, &dwData);
	if(dwRet)						return dwRet;

	dwData &= 0xffffff0f;
	dwData |= count << 4;
	/* WX^3(RENV3) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9e, dwData);	
	if(dwRet)						return dwRet;

	/* ɐI */
	/* WX^Q(RENV2)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdd, &dwData);
	if(dwRet)						return dwRet;

	if(pol) dwData |= (DWORD) 0x800000;	/*  */
	else	dwData &= (DWORD)~0x800000;	/* オ */

	/* WX^2(RENV2) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9d, dwData);
	return dwRet;
}

/************************************************************/
/* DLS/PCSؑ֐ݒ 											*/
/* 		FfoCXnhCCDLS/PCSgp؂ւ,	*/
/*				ɐCDLS͎̓Cb`/Ȃ	*/
/************************************************************/
DWORD hubcp132_SetDlsSel(DWORD hDevID, WORD axis, WORD enable, WORD pol, WORD motion, WORD latch)
{
	BYTE	byData;
	DWORD	dwRmd;
	DWORD	dwEnv;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO ܂ */
	/* DLS/PCSgp؂ւ0`2ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))		return 0x0100;
	if((enable < 0) || (enable > 2))	return 0x0100;

	/* DLS/PCSؑփ|[gǍ */
	dwRet = ubcp130_rPortB(hDevID, CP13_DLSPCS, &byData);
	if(dwRet)							return dwRet;
	/* 샂[h(RMD)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xd7, &dwRmd);
	if(dwRet)							return dwRet;
	/* WX^1(RENV1)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdc, &dwEnv);
	if(dwRet)							return dwRet;

	/* DLS/PCSgpI */
	switch(enable) {
		case 0:
			byData &= (BYTE)~(0x01 << axis);	/* DLS */
			dwRmd  |= (DWORD) 0x100;			/* DLSgp */
			dwEnv  &= (DWORD)~0x1000000;		/* PCS B */
			if(pol) dwEnv |= (DWORD) 0x40;		/* DLS A */
			else	dwEnv &= (DWORD)~0x40;		/* DLS B */
			break;
		case 1:
			byData |= (BYTE) (0x01 << axis);	/* PCS */
			dwRmd  &= (DWORD)~0x100;			/* DLSsgp */
			dwEnv  &= (DWORD)~0x40;				/* DLS B */
			if(pol) dwEnv |= (DWORD) 0x1000000;	/* PCS A */
			else	dwEnv &= (DWORD)~0x1000000;	/* PCS B */
			break;
		case 2:
			byData &= (BYTE)~(0x01 << axis);	/* DLS, PCSƂsgp */
			dwRmd  &= (DWORD)~0x100;			/* DLSsgp */
			break;
		default :						return 0x0100;	/* G[ */
	}

	/* DLS͎̓I */
	if(motion)	dwEnv |= (DWORD) 0x10;			/* ~ */
	else		dwEnv &= (DWORD)~0x10;			/* ̂ */

	/* DLS̓b`I */
	if(latch)	dwEnv |= (DWORD) 0x20;			/* b` */
	else		dwEnv &= (DWORD)~0x20;			/* b`Ȃ */

	/* WX^P(RENV1) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9c, dwEnv);
	if(dwRet)							return dwRet;

	/* 샂[h(PRMD) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x87, dwRmd);
	if(dwRet)							return dwRet;

	/* DLS/PCSؑփ|[g */
	dwRet = ubcp130_wPortB(hDevID, CP13_DLSPCS, byData);
	return dwRet;
}

/********************************************************/
/* INPOS̐ݒ 											*/
/* 		FfoCXnhCCgp/sgpCɐ 	*/
/********************************************************/
DWORD hubcp132_SetInpos(DWORD hDevID, WORD axis, WORD enable, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* 샂[h(RMD)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xd7, &dwData);
	if(dwRet)						return dwRet;

	if(enable)	dwData |= (DWORD) 0x200;	/* gp */
	else		dwData &= (DWORD)~0x200;	/* sgp */

	/* 샂[h(PRMD) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x87, dwData);
	if(dwRet)						return dwRet;

	if(enable) {
	/* WX^P(RENV1)Ǎ */
		dwRet = ubcp130_rReg(hDevID, axis, 0xdc, &dwData);
		if(dwRet)					return dwRet;

		if(pol) dwData |= (DWORD) 0x400000;	/* A */
		else	dwData &= (DWORD)~0x400000;	/* B */

		/* WX^P(RENV1) */
		dwRet = ubcp130_wReg(hDevID, axis, 0x9c, dwData);
	}
	return dwRet;
}

/********************************************************/
/* T[{G[JE^NAo͂̐ݒ 				*/
/* 		FfoCXnhCCgp@			*/
/********************************************************/
DWORD hubcp132_SetSvCtrCl(DWORD hDevID, WORD axis, WORD enable)
{
	DWORD	dwData;
	DWORD	dwRet;			/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* gp@0`3ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))			return 0x100;
	if((enable < 0) || (enable > 3))		return 0x100;

	/* WX^P(RENV1)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)								return dwRet;

	dwData &= (DWORD)~0xC00;
	switch(enable) {
		case 0:								break;	/* sgp */
		case 1:	dwData |= (DWORD) 0x800;	break;	/* _A */
		case 2:	dwData |= (DWORD) 0x400;	break;	/* ُ~ */
		case 3:	dwData |= (DWORD) 0xC00;	break;	/* _Ayшُ~ */
	}
	/* WX^P(RENV1) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/**************************************************************************/
/* \tg~bg̐ݒ 												  */
/* 		FfoCXnhCC+SLS, -SLS, SLSgp/sgpC~@  */
/**************************************************************************/
DWORD hubcp132_SetSls(DWORD hDevID, WORD axis, long psls, long msls, WORD enable, WORD stop)
{
	DWORD	dwRet;			/* ߂l */
	DWORD	dwEnv;

	/* ԍ0`1ȊO */
	/* \tg~bggp+SLS < -SLS͈̎G[ */
	if((axis < 0) || (axis > 1))		return 0x100;
	if((enable) && (psls <= msls))		return 0x100;

	/* WX^4(RENV4)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdf, &dwEnv);
	if(dwRet)							return dwRet;

	if(!enable) {
	/* SLSsgp */
		dwEnv &= 0xffffe3e3;
	} else {
	/* SLSgp */
		/* +SLSf[^ݒ */
		dwRet = ubcp130_wReg(hDevID, axis, 0xa7, psls);
		if(dwRet)						return dwRet;

		/* -SLSf[^ݒ */
		dwRet = ubcp130_wReg(hDevID, axis, 0xa8, msls);
		if(dwRet)						return dwRet;

		dwEnv &= 0xffff0000;
		dwEnv |= 0x00001818;		/* JE^1 */

		/* gp@I */
		if(stop)	dwEnv |= 0x00004040;	/* ~ */
		else		dwEnv |= 0x00002020;	/* ~   */
	}
	/* WX^4(RENV4) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9f, dwEnv);
	return dwRet;
}

/************************************************************/
/* w߃pX̏o͌`̐ݒ 								*/
/* 		FfoCXnhCC						*/
/*				w߃pX̏o͌`(ʃpX/ʃpX) */
/************************************************************/
DWORD hubcp132_SetCmdPulse(DWORD hDevID, WORD axis, WORD cmdpls)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO ܂ */
	/* w߃pX̏o͌`0`3ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))		return 0x0100;
	if((cmdpls < 0) || (cmdpls > 3))	return 0x0100;

	/* WX^P(RENV1)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)							return dwRet;

	dwData &= 0xfffffff8;
	switch(cmdpls) {
		case 0:	dwData |= (DWORD)0x04;	break;	/*  */
		case 1:	dwData |= (DWORD)0x02;	break;	/*  */
		case 2:	dwData |= (DWORD)0x07;	break;
		case 3:	dwData |= (DWORD)0x00;	break;
	}

	/* WX^P(RENV1) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/************************************************************/
/* `ݒ 											*/
/* 		FfoCXnhCC`(/S)	*/
/************************************************************/
DWORD hubcp132_SetAccProfile(DWORD hDevID, WORD axis, WORD accpro)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* 샂[h(RMD)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xd7, &dwData);
	if(dwRet)						return dwRet;

	if(accpro)	dwData |= (DWORD) 0x400;	/* S */
	else		dwData &= (DWORD)~0x400;	/*  */

	/* 샂[h(PRMD) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

/************************************************************************/
/* _̐ݒ 													*/
/* 		FfoCXnhCC_̐ݒ(/}jA)	*/
/************************************************************************/
DWORD hubcp132_SetAutoDec(DWORD hDevID, WORD axis, WORD para)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* 샂[h(RMD)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xd7, &dwData);
	if(dwRet)						return dwRet;

	if(para)	dwData |= (DWORD) 0x2000;	/* }jA */
	else		dwData &= (DWORD)~0x2000;	/*  */

	/* 샂[h(PRMD) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

/********************************************************/
/*					Ǎ݌n̊֐						*/
/********************************************************/
/********************************************************/
/* CXe[^XǍ 								*/
/* 		FfoCXnhCCCXe[^X 	*/
/********************************************************/
DWORD hubcp132_ReadMainSts(DWORD hDevID, WORD axis, WORD* msts)
{
	WORD	wData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* CXe[^XǍ */
	dwRet = ubcp130_rMstsW(hDevID, axis, &wData);
	if(dwRet)						return dwRet;

	*msts = wData;
	return 0;
}

/********************************************************/
/* G[Xe[^XǍ 								*/
/* 		FfoCXnhCCG[Xe[^X	*/
/********************************************************/
DWORD hubcp132_ReadErrorSts(DWORD hDevID, WORD axis, DWORD* ests)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* G[Xe[^XǍ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xf2, &dwData);
	if(dwRet)						return dwRet;

	*ests = dwData;
	return 0;
}

/********************************************************/
/* CxgXe[^XǍ 							*/
/* 		FfoCXnhCCCxgXe[^X	*/
/********************************************************/
DWORD hubcp132_ReadEventSts(DWORD hDevID, WORD axis, DWORD* ists)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* CxgXe[^XǍ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xf3, &dwData);
	if(dwRet)						return dwRet;

	*ists = dwData;
	return 0;
}

/********************************************************/
/* TuXe[^XǍ 								*/
/* 		FfoCXnhCCTuXe[^X 		*/
/********************************************************/
DWORD hubcp132_ReadSubSts(DWORD hDevID, WORD axis, WORD* ssts)
{
	WORD	wData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* TuXe[^XǍ */
	dwRet = ubcp130_rSstsW(hDevID, axis, &wData);
	if(dwRet)						return dwRet;

	*ssts = wData;
	return 0;
}

/********************************************************/
/* gXe[^XǍ 								*/
/* 		FfoCXnhCCgXe[^X 		*/
/********************************************************/
DWORD hubcp132_ReadExSts(DWORD hDevID, WORD axis, DWORD* exsts)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* gXe[^XǍ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xf1, &dwData);
	if(dwRet)						return dwRet;

	*exsts = dwData;
	return 0;
}

/****************************************************/
/* ԃXe[^XǍ 							*/
/* 		FfoCXnhCԃXe[^X 	    */
/****************************************************/
DWORD hubcp132_ReadIpSts(DWORD hDevID, DWORD* ipsts)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԃXe[^XǍ */
	dwRet = ubcp130_rReg(hDevID, 0, 0xff, &dwData);
	if(dwRet)						return dwRet;

	*ipsts = dwData;
	return 0;
}

/********************************************/
/* xǍ 								*/
/* 		FfoCXnhCCx 	*/
/********************************************/
DWORD hubcp132_ReadSpd(DWORD hDevID, WORD axis, WORD* spd)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* xǍ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xf5, &dwData);
	if(dwRet)						return dwRet;

	dwData &= 0x0000ffff;
	*spd = (WORD)dwData;
	return 0;
}

/****************************************************************/
/* JE^Ǎ 												*/
/* 		FfoCXnhCCǍJE^CJE^l	*/
/****************************************************************/
DWORD hubcp132_ReadCtr(DWORD hDevID, WORD axis, WORD selctr, long* count)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* ǍJE^1`4ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))		return 0x0100;
	if((selctr < 1) || (selctr > 4))	return 0x0100;

	/* JE^Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, (BYTE)(0xe2 + selctr), &dwData);
	if(dwRet)							return dwRet;

	*count = dwData;
	return 0;
}

/************************************************************/
/*						ݒn̊֐					*/
/************************************************************/
/********************************************************/
/* x[Xx̐ݒ 									*/
/* 		FfoCXnhCCx[XxWX^	*/
/********************************************************/
DWORD hubcp132_SetFLSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* xWX^1`0xffffȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if((!spd) || (spd > 0xffff))	return 0x0100;

	/* PRFL̏ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x81, spd);
	return dwRet;
}

/********************************************************/
/* ⏕x̐ݒ 										*/
/* 		FfoCXnhCC⏕xWX^	*/
/********************************************************/
DWORD hubcp132_SetAuxSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* xWX^1`0xffffȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if((!spd) || (spd > 0xffff))	return 0x0100;

	/* RFȀ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x9b, spd);
	return dwRet;
}

/********************************************************************************/
/* [g̐ݒ 															*/
/* 		FfoCXnhCC[g 									*/
/* 			NbNg = 19660800Hz 									*/
/* 			(b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800	*/
/* 			r(b) = (PRFH - PRFL) * (PRUR + 1) * 8 / 19660800	*/
/********************************************************************************/
DWORD hubcp132_SetAccRate(DWORD hDevID, WORD axis, DWORD rate)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* [g1`0xffffȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if((!rate) || (rate > 0xffff))	return 0x0100;

	/* PRUȐ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x83, rate);
	return dwRet;
}

/********************************************************/
/* [g̐ݒ 									*/
/* 		FfoCXnhCC[g			*/
/********************************************************/
DWORD hubcp132_SetDecRate(DWORD hDevID, WORD axis, DWORD rate)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	/* [g0`0xffffȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if(rate > 0xffff)				return 0x0100;

	/* PRDȐ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x84, rate);
	return dwRet;
}

/********************************************************/
/* {ݒl(MG)̐ݒ 								*/
/* 		FfoCXnhCC{ݒl(MG)		*/
/* 			MG = 300 / { - 1 						*/
/********************************************************/
DWORD hubcp132_SetMult(DWORD hDevID, WORD axis, DWORD rmg)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* {ݒl2`0xfffȊO͈̎G[ */
	if((axis < 0) || (axis > 1))		return 0x0100;
	if((rmg < 2) || (rmg > 0xfff))		return 0x0100;

	/* PRMG̏ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x85, rmg);
	return dwRet;
}

/************************************************************/
/* Cxg}XN̐ݒ 									*/
/* 		FfoCXnhCCCxg}XNf[^	*/
/************************************************************/
DWORD hubcp132_SetEventMask(DWORD hDevID, WORD axis, DWORD mask)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* Cxg}XNf[^ 0`0x0003ffffȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if(mask & 0xfff80000)			return 0x0100;

	/* Cxg}XN(RIRQ)WX^̏ */
	dwRet = ubcp130_wReg(hDevID, axis, 0xac, mask);
	return dwRet;
}

/************************************************/
/* _̐ݒ 								*/
/* 		FfoCXnhCC_		*/
/************************************************/
DWORD hubcp132_SetDecPoint(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;

	/* PRDP̏ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x86, dstnc);
	return dwRet;
}

/********************************************************/
/*					^pݒn̊֐					*/
/********************************************************/
/****************************************************/
/* 샂[h 								*/
/* 		FfoCXnhCC샂[h		*/
/****************************************************/
DWORD hubcp132_WritOpeMode(DWORD hDevID, WORD axis, WORD mode)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* 샂[hُ͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if(mode & 0xff80)				return 0x0100;
	if(!mod_tbl[mode])				return 0x0100;

	/* 샂[h(RMD)Ǎ */
	dwRet = ubcp130_rReg(hDevID, axis, 0xd7, &dwData);
	if(dwRet)						return dwRet;

	dwData &= 0xef3a700;
	if(mode == 0x42)	dwData |= 0x4041;
	else				dwData |= mode;	

	/* 샂[h(PRMD) */
	dwRet = ubcp130_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

/********************************************************/
/* 쑬xWX^̐ݒ 								*/
/* 		FfoCXnhCC쑬xWX^	*/
/********************************************************/
DWORD hubcp132_WritFHSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂ */
	/* xWX^1`0xffffȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if((!spd) || (spd > 0xffff))	return 0x0100;

	/* PRFH̏ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x82, spd);
	return dwRet;
}

/************************************************/
/* ʒu߈ړʂ̐ݒ 						*/
/* 		FfoCXnhCCړ		*/
/************************************************/
DWORD hubcp132_WritPos(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	/* ړʃWX^-134217728`134217727ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if((dstnc < -134217728) || (dstnc > 134217727))	return 0x0100;

	/* PRMV̏ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x80, dstnc);
	return dwRet;
}

/************************************************/
/* Ԃ̈ړʂ̐ݒ 						*/
/* 		FfoCXnhCCړ		*/
/************************************************/
DWORD hubcp132_WritLine(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO͈̎G[ */
	/* ړʃWX^-134217728`134217727ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))	return 0x0100;
	if((dstnc < -134217728) || (dstnc > 134217727))	return 0x0100;

	/* PRMV̏ */
	dwRet = ubcp130_wReg(hDevID, axis, 0x80, dstnc);
	return dwRet;
}

/************************************************************/
/* ~ʕԂ̃f[^ݒ 									*/
/* 		FfoCXnhCgݍ킹CI_ʒu1,	*/
/*				I_ʒu2CSʒu1CSʒu2				*/
/************************************************************/
DWORD hubcp132_WritCircl(DWORD hDevID, WORD axis,
						long dstnc1, long dstnc2, long center1,long center2)
{
	DWORD	dwRet; 				/* ߂l */
	WORD	ax1,ax2;

	/* Ԏ̑gݍ킹̈0ȊO̎̓G[ */
	/* ړʃWX^-134217728`0x7ffffffȊO͈̎G[ */
	if(axis)				return 0x0100;
	if((dstnc1 < -134217728) || (dstnc1 > 134217727))	return 0x0100;
	if((dstnc2 < -134217728) || (dstnc2 > 134217727))	return 0x0100;

	ax1 = 0;/* X(0) */
	ax2 = 1;/* Y(1) */

	/* PRMV(I_ʒu)̏ */
	dwRet = ubcp130_wReg(hDevID, ax1, 0x80, dstnc1);	/* X */
	if(dwRet)						return dwRet;
	dwRet = ubcp130_wReg(hDevID, ax2, 0x80, dstnc2);	/* Y */
	if(dwRet)						return dwRet;
	/* PRIP(Sʒu)̏ */
	dwRet = ubcp130_wReg(hDevID, ax1, 0x88, center1);	/* X */
	if(dwRet)						return dwRet;
	dwRet = ubcp130_wReg(hDevID, ax2, 0x88, center2);	/* Y */
	return dwRet;
}

/****************************************************************/
/* JE^vZbg 											*/
/* 		FfoCXnhC vZbglCJE^I	*/
/****************************************************************/
DWORD hubcp132_WritCtr(DWORD hDevID, WORD axis, long preset, WORD selctr)
{
	BYTE	byCmd;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`1ȊO܂̓JE^1`4ȊO̎̓G[ */
	/* vZbgl-134217728`134217727ȊO͈̎G[ */
	if((axis < 0) || (axis > 1))		return 0x0100;
	if((selctr < 1) || (selctr > 4))	return 0x0100;
	if((preset < -134217728) || (preset > 134217727))	return 0x0100;

	/* vZbgl */
	byCmd = (BYTE)(0xa2 + selctr);	/* JE^I */
	dwRet = ubcp130_wReg(hDevID, axis, byCmd, preset);
	return dwRet;
}

/********************************************************/
/*					쐧n̊֐					*/
/********************************************************/
/****************************************************/
/* ~ 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_DecStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X`Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)((axis << 8) | 0x4a));		/* R}h */

	return dwRet;
}

/****************************************************/
/* ~ 											*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_QuickStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X`Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)((axis << 8) | 0x49));		/* R}h */

	return dwRet;
}

/****************************************************/
/* ~ 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_EmgStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X`Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)((axis << 8) | 0x05));		/* R}h */

	return dwRet;
}

/****************************************************/
/* X^[g 									*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_AccStart(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X`Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)((axis << 8) | 0x53));		/* R}h */

	return dwRet;
}

/****************************************************/
/* FH葬X^[g 									*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_CnstStartFH(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X`Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)((axis << 8) | 0x51));		/* R}h */

	return dwRet;
}

/****************************************************/
/* FL葬X^[g 									*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_CnstStartFL(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X`Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)((axis << 8) | 0x50));		/* R}h */

	return dwRet;
}

/****************************************************/
/* FH葬X^[g㌸~ 						*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_ConstStartByDec(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X`Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)((axis << 8) | 0x52));		/* R}h */

	return dwRet;
}

/****************************************************/
/* T[{I 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_SvOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X - Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x18));
	return dwRet;
}

/****************************************************/
/* T[{It 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_SvOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X - Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x10));
	return dwRet;
}

/****************************************************/
/* T[{ZbgI 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_SvResetOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0xfȊO̎̓G[ */
	if((axis <= 0) || (axis > 0xf))	return 0x0100;

	/* X - Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x19));
	return dwRet;
}

/****************************************************/
/* T[{ZbgIt 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_SvResetOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X - Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x11));
	return dwRet;
}

/****************************************************/
/* pX[^I 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_PMOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X - Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x10));
	return dwRet;
}

/****************************************************/
/* pX[^It 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hubcp132_PMOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0x01`0x03ȊO̎̓G[ */
	if((axis <= 0) || (axis > 0x03))	return 0x0100;

	/* X - Y */
	dwRet = ubcp130_wCmdW(hDevID, 0, (WORD)(((axis & 0x0f) << 8) | 0x18));
	return dwRet;
}

/********************************************************/
/* [ǧvZ 									*/
/* 		F[gCԁCeg,			*/
/*				ekC`C\ 					*/
/********************************************************/
DWORD hubcp132_CalAccRate(DWORD* rate, DWORD dwtime, DWORD fh, DWORD fl, WORD pro, WORD s)
{
	double	dblData;
	double	dblTime;
	DWORD	accrate;

	if(!fh)			return 0x0100;
	if(!fl)			return 0x0100;
	if(fh <= fl)	return 0x0100;
	if(!dwtime)		return 0x0100;

	dblTime = (double)dwtime / 1000;		/* (b) */

	if(s) {
	/* ̂r[g:PRUR = 4915200 * ( / (FH - FL)) - 1) */
		dblData = dblTime / (fh - fl + 2 * s);
		dblData = 4915200l * dblData - 1;
		accrate = (DWORD)dblData;
	} else {
		if(pro) {
		/* ̂Ȃr[g:PRUR = 2457600 * ( / (FH - FL)) - 1) */
			dblData = dblTime / (fh - fl);
			dblData = 2457600l * dblData - 1;
			accrate = (DWORD)dblData;
		} else {
		/* [g:PRUR = 4915200 * ( / (FH - FL)) - 1) */
			dblData = dblTime / (fh - fl);
			dblData = 4915200l * dblData - 1;
			accrate = (DWORD)dblData;
		}
	}
	if((accrate > 0xffff) || (!accrate)) 		return 0x0100;
	
	*rate = accrate;
	return 0;
}
